<template>
  <div class="switch-checkbox-wrapper">
    <input
      :id="name"
      :checked="!!value"
      type="checkbox"
      class="switch"
      :name="name"
      @change="$emit('change', $event.target.checked)"
    />
    <label v-if="label" class="cursor-pointer h5 ms-2 mb-0" :for="name">
      {{ label }}
    </label>
  </div>
</template>

<script>
export default {
  model: {
    prop: 'value',
    event: 'change',
  },
  props: {
    name: {
      type: String,
      required: true,
    },
    label: {
      type: String,
      required: false,
      default: '',
    },
    value: {
      type: [Boolean, String, Array],
      default: null,
    },
  },
}
</script>

<style scoped>
.switch-checkbox-wrapper input.switch {
  position: relative;
  top: 2px;
  z-index: 1;
  appearance: none;
  width: 34px;
  height: 14px;
  border-radius: 30px;
  background: #9f9f9f;
  outline: 0;
  cursor: pointer;
}

.switch-checkbox-wrapper input.switch:checked {
  background: #9fe7da;
}

.switch-checkbox-wrapper input.switch:after {
  position: absolute;
  content: '';
  width: 20px;
  height: 20px;
  background: white;
  border-radius: 50%;
  left: -1px;
  top: 50%;
  transform: translateY(-50%);
  box-shadow: 0px 0px 2px 0px rgba(0, 0, 0, 0.25);
  transition: all 0.35s;
}

.switch-checkbox-wrapper input.switch:checked:after {
  left: calc(100% - 18px);
  background-color: #00c09d;
}
</style>